package com.steerinfo.baseinfo.meterbasehistarecount.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasehistarecount.model.MeterBaseHisTareCount;
import com.steerinfo.baseinfo.meterbasehistarecount.service.IMeterBaseHisTareCountService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseHisTareCount RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-28 09:33
 * 类描述
 * 修订历史：
 * 日期：2020-06-28
 * 作者：generator
 * 参考：
 * 描述：MeterBaseHisTareCount RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasehistarecounts")
@Api(value = "/${api.version}/meterbasehistarecounts", tags = "历史皮重计算配置 - MeterBaseHisTareCountController")
public class MeterBaseHisTareCountController extends BaseRESTfulController {

    @Autowired
    IMeterBaseHisTareCountService meterBaseHisTareCountService;

    @ApiOperation(value = "获取列表-网页", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasehistarecount:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseHisTareCount> list = meterBaseHisTareCountService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasehistarecount:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseHisTareCount> list = meterBaseHisTareCountService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建-网页", notes = "根据MeterBaseHisTareCount对象创建")
    @ApiImplicitParam(name = "meterBaseHisTareCount", value = "详细实体meterBaseHisTareCount", required = true, dataType = "MeterBaseHisTareCount")
    //@RequiresPermissions("meterbasehistarecount:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseHisTareCount model) {
        try {
            String msg = meterBaseHisTareCountService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasehistarecount:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseHisTareCount meterBaseHisTareCount = meterBaseHisTareCountService.getById(id);
            return success(meterBaseHisTareCount);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息-网页", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseHisTareCount信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseHisTareCount", value = "详细实体meterBaseHisTareCount", required = true, dataType = "MeterBaseHisTareCount")
    })
    //@RequiresPermissions("meterbasehistarecount:update")
    @Transactional
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseHisTareCount model) {
        try {
            String msg = meterBaseHisTareCountService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasehistarecount:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseHisTareCountService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "启用-网页", notes = "根据传过来的MeterBaseHisTareCount集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseHisTareCount", value = "详细实体MeterBaseHisTareCount", required = true, dataType = "MeterBaseHisTareCount")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody MeterBaseHisTareCount model) {
        try {
            String msg = meterBaseHisTareCountService.Recovery(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "废除-网页", notes = "根据传过来的MeterBaseHisTareCount集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseHisTareCount", value = "详细实体MeterBaseHisTareCount", required = true, dataType = "MeterBaseHisTareCount")
    })
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody MeterBaseHisTareCount model) {
        try {
            String msg = meterBaseHisTareCountService.abolish(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }


    @ApiOperation(value = "按编码查询历史皮重配置子表的数据", notes = "按编码查询历史皮重配置子表的数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseHisTareCount", value = "详细实体MeterBaseHisTareCount", required = true, dataType = "MeterBaseHisTareCount")
    })
    @Transactional
    @PostMapping(value = "/doQuerySpecWf")
    public RESTfulResult selectCountDBy(@RequestBody MeterBaseHisTareCount model) {
        try {
            List<MeterBaseHisTareCount> tareCountList = meterBaseHisTareCountService.doQuerySpecWf(model);
            return success(tareCountList);
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！" + e.getMessage());
        }
    }
}
